<script setup lang="ts">
  const { appointmentId } = useAppointment();
  const { isBroadCastEnabled } = useVideoCall();
  const muting = ref(false);

  const handleCopyLink = () => {
    navigator.clipboard.writeText(
      `${document.location.origin}/presentation/${appointmentId.value}`,
    );
  };

  const muteAll = () => {
    muting.value = true;
    const updatedParticipantList: { [key: string]: object } = {};
    // Accommodate muting mics
    const newSetting = { setAudio: false };
    for (const id in window.dailyCallInstance.participants()) {
      // Do not update the local participant's
      // device (aka the instructor)
      if (id === 'local') continue;

      updatedParticipantList[id] = newSetting;
    }
    window.dailyCallInstance.updateParticipants(updatedParticipantList);
    setTimeout(() => {
      muting.value = false;
    }, 1000);
  };
</script>

<template>
  <div
    class="shadow-5 border-information-disabled bg-background-raised flex flex-col gap-4 border-t p-5"
  >
    <div class="border-information-disabled flex space-x-3 border-b pb-4">
      <BroadcastModeSetup />
    </div>

    <div class="flex gap-3">
      <SwButton variant="action" size="medium" class="flex-1" @click="handleCopyLink">
        <span class="i-sw-solid:copy text-base" />
        <span>{{ $t('copyLink') }}</span>
      </SwButton>

      <SwButton
        variant="danger"
        size="medium"
        class="flex-1"
        :disabled="isBroadCastEnabled || muting"
        @click="muteAll"
      >
        <span class="i-sw-solid:microphone-slash text-base" />
        <span>{{ $t('muteAll') }}</span>
      </SwButton>
    </div>
  </div>
</template>
